#!/bin/bash
# One way conversion of "_alt" texture variants into their defaults.
#
# By default, everything is commented out. 
# Sections separated by "=" are for un-related changes. While sub-sections separated by "-" are for, individual, but related changes.
#

cd ..

#===================================================================================================================================
#: Original Conifeorus Litter:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_coniferous_litter_alt.png textures/default_mcl_core/soil/default_coniferous_litter.png
#cp alternate_textures/texture_alts/default_coniferous_litter_side_alt.png textures/default_mcl_core/soil/default_coniferous_litter_side.png


#=====================================================
#: Darker, and softer Conifeorus Litter:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_coniferous_litter_alt2.png textures/default_mcl_core/soil/default_coniferous_litter.png
#cp alternate_textures/texture_alts/default_coniferous_litter_side_alt2.png textures/default_mcl_core/soil/default_coniferous_litter_side.png


#=====================================================
#: Original, darker brown dirt:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_dirt_alt.png textures/default_mcl_core/soil/default_dirt.png

#--------------------------------------------------
#: More MC-like, brown/pepper dirt:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_dirt_alt2.png textures/default_mcl_core/soil/default_dirt.png


#=====================================================
#: Fuller jungle grass:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_junglegrass_alt.png textures/default_mcl_core/plants/default_junglegrass.png


#=====================================================
#: Classic Grey Iron ore:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_mineral_iron_alt_classicGrey.png textures/default_mcl_core/minerals_ores/default_mineral_iron.png
#cp alternate_textures/texture_alts/mcl_core_iron_ore_alt_classicGrey.png textures/default_mcl_core/minerals_ores/mcl_core_iron_ore.png


#=====================================================
# Torches with better wood grain:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_torch_on_floor_alt.png textures/default_mcl_core/default_torch_on_floor.png
#cp alternate_textures/texture_alts/default_torch_on_floor_animated_alt.png textures/default_mcl_core/default_torch_on_floor_animated.png
#cp alternate_textures/texture_alts/mcl_torch_on_floor_animated_alt.png textures/default_mcl_core/mcl_torch_on_floor_animated.png
#cp alternate_textures/texture_alts/soul_torch_on_floor_alt.png textures/mcl_blackstone/soul_torch_on_floor.png
#cp alternate_textures/texture_alts/soul_torch_on_floor_animated_alt.png textures/mcl_blackstone/soul_torch_on_floor_animated.png
#cp alternate_textures/texture_alts/mcl_soultorch_on_floor_animated_alt.png textures/mcl_blackstone/mcl_soultorch_on_floor_animated.png
#cp alternate_textures/texture_alts/jeija_torches_off_alt.png textures/redstone/mesecons_torch/jeija_torches_off.png
#cp alternate_textures/texture_alts/jeija_torches_on_alt.png textures/redstone/mesecons_torch/jeija_torches_on.png


#=====================================================
#: Highly saturated MC-like water:
#--------------------------------------------------
#cp alternate_textures/texture_alts/default_water_alt.png textures/default_mcl_core/default_water.png
#cp alternate_textures/texture_alts/default_water_source_animated_alt.png textures/default_mcl_core/default_water_source_animated.png
#cp alternate_textures/texture_alts/default_water_flowing_animated_alt.png textures/default_mcl_core/default_water_flowing_animated.png


#=====================================================
#: Smaller, rounder fire:
#--------------------------------------------------
#cp alternate_textures/texture_alts/fire_basic_flame_animated_alt.png textures/fire_mcl_fire/fire_basic_flame_animated.png


#=====================================================
#: More jagged basalt:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_blackstone_basalt_side_alt.png textures/mcl_blackstone/mcl_blackstone_basalt_side.png


#=====================================================
#: Frayed book pages HUD:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_books_book_bg_alt.png textures/default_mcl_core/gui_hud/mcl_books_book_bg.png


#=====================================================
#: Copper lump similar to gold/iron nuggets:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_copper_raw_alt.png textures/mcl_copper/mcl_copper_raw.png


#=====================================================
#: Darker, softer, original Andesite:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_core_andesite_alt.png textures/default_mcl_core/stone/mcl_core_andesite.png
#cp alternate_textures/texture_alts/mcl_core_andesite_smooth_alt.png textures/default_mcl_core/stone/mcl_core_andesite_smooth.png
#cp alternate_textures/texture_alts/mcl_stairs_andesite_smooth_slab_alt.png textures/default_mcl_core/stone/mcl_stairs_andesite_smooth_slab.png

#--------------------------------------------------
#: Horizontal striation, original Diorite:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_core_diorite_alt.png textures/default_mcl_core/stone/mcl_core_diorite_alt.png
#cp alternate_textures/texture_alts/mcl_core_diorite_smooth_alt.png textures/default_mcl_core/stone/mcl_core_diorite_smooth.png
#cp alternate_textures/texture_alts/mcl_stairs_diorite_smooth_slab_alt.png textures/default_mcl_core/stone/mcl_stairs_diorite_smooth_slab.png

#--------------------------------------------------
#: Softer, original Granite:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_core_granite_alt.png textures/default_mcl_core/stone/mcl_core_granite.png
#cp alternate_textures/texture_alts/mcl_core_granite_smooth_alt.png textures/default_mcl_core/stone/mcl_core_granite_smooth.png
#cp alternate_textures/texture_alts/mcl_stairs_granite_smooth_slab_alt.png textures/default_mcl_core/stone/mcl_stairs_granite_smooth_slab.png


#=====================================================
#: Slightly ligher Birch leaves:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_core_leaves_birch_alt.png textures/default_mcl_core/trees/mcl_core_leaves_birch.png


#=====================================================
#: Darker vines:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_core_vine_alt.png textures/default_mcl_core/plants/mcl_core_vine.png
#cp alternate_textures/texture_alts/mcl_core_vine_inventory_alt.png textures/default_mcl_core/plants/mcl_core_vine_inventory.png


#=====================================================
#: Bluer allium flower:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_flowers_allium_alt.png textures/flowers_mcl_flowers/mcl_flowers_allium.png

#--------------------------------------------------
#: White tipped Azure Bluet flower:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_flowers_azure_bluet_alt.png textures/flowers_mcl_flowers/mcl_flowers_azure_bluet.png

#--------------------------------------------------
#: Magenta lilac flower :
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_flowers_double_plant_syringa_bottom_alt.png textures/flowers_mcl_flowers/mcl_flowers_double_plant_syringa_bottom.png
#cp alternate_textures/texture_alts/mcl_flowers_double_plant_syringa_top_alt.png textures/flowers_mcl_flowers/mcl_flowers_double_plant_syringa_top.png

#--------------------------------------------------
#: Brighter white, more yellow Daisy flower:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_flowers_oxeye_daisy_alt.png textures/flowers_mcl_flowers/mcl_flowers_oxeye_daisy.png


#=====================================================
#: Prettier mangrove leaves:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_mangrove_leaves_alt.png textures/mcl_wild_update/mcl_mangrove_leaves.png


#=====================================================
#: Darker mangrove roots:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_mangrove_roots_side_alt.png textures/mcl_wild_update/mcl_mangrove_roots_side.png
#cp alternate_textures/texture_alts/mcl_mangrove_roots_top_alt.png textures/mcl_wild_update/mcl_mangrove_roots_top.png


#=====================================================
#: Teal colored Mud, closer to MC:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_mud_alt.png textures/mcl_wild_update/mcl_mud.png


#=====================================================
#: Lighter brown mud:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_mud_bricks_alt.png textures/mcl_wild_update/mcl_mud_bricks.png
#cp alternate_textures/texture_alts/mcl_mud_packed_mud_alt.png textures/mcl_wild_update/mcl_mud_packed_mud.png


#=====================================================
#: Original, non-red netherrack:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_nether_netherrack_alt_old.png textures/mcl_nether/mcl_nether_netherrack.png
#cp alternate_textures/texture_alts/rib_armor_trim_smithing_template_alt.png textures/mcl_armor/mcl_armor_trims/rib_armor_trim_smithing_template.png

#--------------------------------------------------
#: Dark, wine-colored, nether bricks:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_nether_nether_brick_alt.png textures/mcl_nether/mcl_nether_nether_brick.png
#cp alternate_textures/texture_alts/mcl_nether_chiseled_nether_bricks_alt.png textures/mcl_nether/mcl_nether_chiseled_nether_bricks.png
#cp alternate_textures/texture_alts/mcl_nether_cracked_nether_bricks_alt.png textures/mcl_nether/mcl_nether_cracked_nether_bricks.png
#cp alternate_textures/texture_alts/mcl_fences_fence_nether_brick_alt.png textures/mcl_fences/mcl_fences_fence_nether_brick.png
#cp alternate_textures/texture_alts/mcl_fences_fence_gate_nether_brick_alt.png textures/mcl_fences/mcl_fences_fence_gate_nether_brick.png


#--------------------------------------------------
#: Blood-red colored, nether bricks:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_nether_red_nether_brick_alt.png textures/mcl_nether/mcl_nether_red_nether_brick.png
#cp alternate_textures/texture_alts/mcl_fences_fence_red_nether_brick_alt.png textures/mcl_fences/mcl_fences_fence_red_nether_brick.png
#cp alternate_textures/texture_alts/mcl_fences_fence_gate_red_nether_brick_alt.png textures/mcl_fences/mcl_fences_fence_gate_red_nether_brick.png


#=====================================================
#: Polished Deepslate, without lines:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_polished_deepslate_alt.png textures/mcl_deepslate/mcl_polished_deepslate.png


#=====================================================
#: Smaller, steel-colored protector logo:
#--------------------------------------------------
#cp alternate_textures/texture_alts/protector_logo_alt.png skyfactory/protector/protector_logo.png

#--------------------------------------------------
#: Smaller, copper-colored protector logo:
#--------------------------------------------------
#cp alternate_textures/texture_alts/protector_logo_alt_copper.png skyfactory/protector/protector_logo.png

#--------------------------------------------------
#: Smaller, gold-colored protector logo:
#--------------------------------------------------
#cp alternate_textures/texture_alts/protector_logo_alt_gold.png skyfactory/protector/protector_logo.png


#=====================================================
#: Smoker, with lighter wood grain:
#--------------------------------------------------
#cp alternate_textures/texture_alts/smoker_front_alt.png textures/blast_furnace_smoker/smoker_front.png
#cp alternate_textures/texture_alts/smoker_front_on_alt.png textures/blast_furnace_smoker/smoker_front_on.png
#cp alternate_textures/texture_alts/smoker_front_open_alt.png textures/blast_furnace_smoker/smoker_front_open.png
#cp alternate_textures/texture_alts/smoker_side_alt.png textures/blast_furnace_smoker/smoker_side.png
#cp alternate_textures/texture_alts/smoker_top_alt.png textures/blast_furnace_smoker/smoker_top.png


#===========================================================
#: Bread icons for Stamina HUD:
#------------------------------------------------------
#cp alternate_textures/texture_alts/stamina_hud_bg_alt.png minetest_game_mods/stamina/stamina_hud_bg.png
#cp alternate_textures/texture_alts/stamina_hud_fg_alt.png minetest_game_mods/stamina/stamina_hud_fg.png
#cp alternate_textures/texture_alts/stamina_hud_poison_alt.png minetest_game_mods/stamina/stamina_hud_poison.png


#===========================================================
#: Light orange glowstone, and glowstone related items:
#------------------------------------------------------
#cp alternate_textures/texture_alts/mcl_nether_glowstone_alt.png textures/mcl_nether/mcl_nether_glowstone.png
#cp alternate_textures/texture_alts/mcl_nether_glowstone_dust_alt.png textures/mcl_nether/mcl_nether_glowstone_dust.png

#cp alternate_textures/texture_alts/portal_alt.png textures/beds_mcl_beds/portal.png
#cp alternate_textures/texture_alts/respawn_anchor_side1_alt.png textures/beds_mcl_beds/respawn_anchor_side1.png
#cp alternate_textures/texture_alts/respawn_anchor_side2_alt.png textures/beds_mcl_beds/respawn_anchor_side2.png
#cp alternate_textures/texture_alts/respawn_anchor_side3_alt.png textures/beds_mcl_beds/respawn_anchor_side3.png
#cp alternate_textures/texture_alts/respawn_anchor_side4_alt.png textures/beds_mcl_beds/respawn_anchor_side4.png
#cp alternate_textures/texture_alts/respawn_anchor_top_on_alt.png textures/beds_mcl_beds/respawn_anchor_top_on.png


#=====================================================
#: Brighter, MC-like End Stone:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_end_end_bricks_alt.png textures/mcl_end/mcl_end_end_bricks.png
#cp alternate_textures/texture_alts/mcl_end_end_stone_alt.png textures/mcl_end/mcl_end_end_stone.png
#cp alternate_textures/texture_alts/eye_armor_trim_smithing_template_alt.png textures/mcl_armor/mcl_armor_trims/eye_armor_trim_smithing_template.png

#--------------------------------------------------
#: More MC-like Purpur Stone:
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_end_purpur_block_alt.png textures/mcl_end/mcl_end_purpur_block.png
#cp alternate_textures/texture_alts/mcl_end_purpur_pillar_alt.png textures/mcl_end/mcl_end_purpur_pillar.png
#cp alternate_textures/texture_alts/mcl_end_purpur_pillar_top_alt.png textures/mcl_end/mcl_end_purpur_pillar_top.png
#cp alternate_textures/texture_alts/spire_armor_trim_smithing_template_alt.png textures/mcl_armor/mcl_armor_trims/spire_armor_trim_smithing_template.png


#===========================================================
#===========================================================
#===========================================================
#--------------------------------------------------
#: Backup images for non-Mineclonia, Mcl* games:
#	Fixes model & formspec changes.
#--------------------------------------------------
#cp alternate_textures/texture_alts/mcl_campfires_campfire_fire_old.png textures/mcl_campfires/mcl_campfires_campfire_fire.png
#cp alternate_textures/texture_alts/mcl_campfires_campfire_log_lit_old.png textures/mcl_campfires/mcl_campfires_campfire_log_lit.png
#cp alternate_textures/texture_alts/mcl_campfires_log_old.png textures/mcl_campfires/mcl_campfires_log.png
#cp alternate_textures/texture_alts/mcl_campfires_soul_campfire_fire_old.png textures/mcl_campfires/mcl_campfires_soul_campfire_fire.png
#cp alternate_textures/texture_alts/mcl_campfires_soul_campfire_log_lit_old.png textures/mcl_campfires/mcl_campfires_soul_campfire_log_lit.png

#cp alternate_textures/texture_alts/mcl_enchanting_lapis_background_old.png textures/mcl_enchanting/mcl_enchanting_lapis_background.png

#cp alternate_textures/texture_alts/mcl_heads_creeper_old.png textures/mobs_mc/mcl_heads/mcl_heads_creeper.png
#cp alternate_textures/texture_alts/mcl_heads_skeleton_old.png textures/mobs_mc/mcl_heads/mcl_heads_skeleton.png
#cp alternate_textures/texture_alts/mcl_heads_steve_old.png textures/mobs_mc/mcl_heads/mcl_heads_steve.png
#cp alternate_textures/texture_alts/mcl_heads_wither_skeleton_old.png textures/mobs_mc/mcl_heads/mcl_heads_wither_skeleton.png
#cp alternate_textures/texture_alts/mcl_heads_zombie_old.png textures/mobs_mc/mcl_heads/mcl_heads_zombie.png



#===================================================================================================================================#

